`timescale 1ns / 1ps
module rategen(
    input clk,
    input rst,
    output cy,
    output blink
    );
//Generate 1 clock wide enable pulse, and square signal (for optional LED blinking)

reg [22:0] Q; 
wire cy_dfreq; //Double freq.
always @(posedge clk) 
   if (rst | cy_dfreq) 
      Q <= 0; 
   else 
      Q <= Q + 1;

assign cy_dfreq =	(Q == 7999999);     //Double freq. is 0.5 Hz
//assign cy_dfreq =	(Q == 1);           //for analysis



reg blink_ff; 
always @(posedge clk)
   if(rst)
      blink_ff <= 0;
   else if(cy_dfreq)
      blink_ff <= ~blink_ff;
      
assign blink = blink_ff;
assign cy = (cy_dfreq & (blink_ff==0));

endmodule
